;; plog.el - emacs-wiki addon for embedding photographs 

;; Copyright (C) 2004 Ganesh Swami

;; Author: Ganesh Swami <ganesh@iamganesh.com>
;; Version: 0.2
;; Created: Aug 21 2004

;; Based on code by Satyaki Das
;; http://chicory.stanford.edu/satyaki/backpacking/EmacsWikiAlbumCreation.html

;; This is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; this software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.
	     
;;; Commentary:

;; Read The Fine Documentation at
;; http://www.sfu.ca/~gswamina/EmacsWikiBlog.html


;;; Code


;; Handle <thumb> tags properly...
(defun gs-emacs-wiki-thumbnail-tag (beg end attrs highlight-p)
  (if highlight-p
      (goto-char end)
    (let ((end-marker (set-marker (make-marker) (1+ end))))
      (save-restriction
        (narrow-to-region beg end)

	(let ((image-list (split-string (buffer-substring beg end)"\n"))
	      (prefix (cdr (assoc "prefix" attrs)))
	      (dir (cdr (assoc "dir" attrs)))
	      (thdir (cdr (assoc "thdir" attrs))))

	  (if (null thdir)
	      (setq thdir "images/th"))
	  (if (null dir)
	      (setq dir "images"))
	  (if (null prefix)
	      (setq prefix "th."))
	  
	  (delete-region beg end)
	  (goto-char (point-min))
	  
	  (mapcar '(lambda (x)
		     (let ((line (split-string x)))
		       (let ((file (first line)))
			 (insert "<div class=\"plog\">\n")
			 (insert (format "<a href=\"%s\">" (concat dir "/" file)))
			 (insert (format "<img src=\"%s\" /></a>" (concat thdir "/" prefix file)))
			 (insert (format "\n<br />%s" (substring x (length file))))
			 (insert "\n</div>\n\n")
			 ))) image-list)
	  ))
      ;; This is needed to stop the content that follows from wrapping

      (insert "<br class=\"clearboth\" /><br /> \n\n")
      (goto-char end-marker))))


